//+------------------------------------------------------------------+
//|                                        position_reversal_v3.mq5  |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property description "Reverse position and study \"DEAL_POSITION_ID\" history deals"
#property description "    \"DEAL_POSITION_ID\"  "
#property script_show_inputs
//---
input datetime start=D'2016.08.05 09:00:00';
//---
#include <Trade\Trade.mqh>
//--- variable
CTrade   my_trade;         // object CTrade
ulong    my_magic=18615;   // magic
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
int OnStart()
  {
//---
   if(AccountInfoInteger(ACCOUNT_MARGIN_MODE)==ACCOUNT_MARGIN_MODE_RETAIL_HEDGING)
     {
      Print("This script cannot be run on a hedge;      ");
      return(INIT_FAILED);
     }
//---
   my_trade.SetExpertMagicNumber(my_magic);
   Print("Buy 0.01, \"EURUSD\"");
   my_trade.Buy(0.01,"EURUSD");
   Sleep(600);
   Print_IDs();
   Sleep(6000);
//---
   Print("Sell 0.02, \"EURUSD\"");
   my_trade.Sell(0.02,"EURUSD");
   Sleep(600);
   Print_IDs();
   Sleep(6000);
//---
   Print("PositionClose, \"EURUSD\"");
   my_trade.PositionClose("EURUSD");
   Sleep(600);
   Print_IDs();
   Sleep(6000);
//--- succeed
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| List all positions and deals                                     |
//+------------------------------------------------------------------+
void Print_IDs(void)
  {
   for(int i=0;i<PositionsTotal();i++)
     {
      //---         
      string pos_symbol=PositionGetSymbol((uint)i);
      if(pos_symbol!=NULL)
        {
         //---         
         ulong position_ID=PositionGetInteger(POSITION_IDENTIFIER);
         Print("Position ",pos_symbol," POSITION_IDENTIFIER #",position_ID);
        }
     }
//--- request trade history 
   HistorySelect(start,TimeCurrent());
   uint     total    =HistoryDealsTotal();
   ulong    ticket   =0;
   long     deal_id  =0;
   double   volume   =0.0;
   double   profit   =0.0;
   string   symbol   =NULL;
//--- for all deals 
   for(uint i=0;i<total;i++)
     {
      //--- try to get deals ticket 
      if((ticket=HistoryDealGetTicket(i))>0)
        {
         //--- get deals properties 
         deal_id  =HistoryDealGetInteger(ticket,DEAL_POSITION_ID);
         volume   =HistoryDealGetDouble(ticket,DEAL_VOLUME);
         profit   =HistoryDealGetDouble(ticket,DEAL_PROFIT);
         symbol   =HistoryDealGetString(ticket,DEAL_SYMBOL);
         Print("Deal ",symbol," volume ",DoubleToString(volume,2),
               " DEAL_POSITION_ID #",deal_id," profit ",DoubleToString(profit,2));
        }
     }
//--- for all orders
   long     order_id       =0;
   double   initial_volume =0.0;
   total=HistoryOrdersTotal();
   datetime time_done=0;
   for(uint i=0;i<total;i++)
     {
      //--- try to get orders ticket
      if((ticket=HistoryOrderGetTicket(i))>0)
        {
         order_id       =HistoryOrderGetInteger(ticket,ORDER_POSITION_ID);
         symbol         =HistoryOrderGetString(ticket,ORDER_SYMBOL);
         initial_volume =HistoryOrderGetDouble(ticket,ORDER_VOLUME_INITIAL);
         ticket         =HistoryOrderGetInteger(ticket,ORDER_TICKET);
         time_done      =(datetime)HistoryOrderGetInteger(ticket,ORDER_TIME_DONE);
         Print("Order ",symbol," initial_volume ",DoubleToString(initial_volume,2),
               " ORDER_POSITION_ID #",order_id," ORDER_TICKET ",ticket," ORDER_TIME_DONE ",time_done);
        }
     }
   Print("");
  }
//+------------------------------------------------------------------+
